// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_msgs:msg/CauseCode.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__CAUSE_CODE__STRUCT_H_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__CAUSE_CODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'cause_code'
#include "etsi_its_denm_msgs/msg/detail/cause_code_type__struct.h"
// Member 'sub_cause_code'
#include "etsi_its_denm_msgs/msg/detail/sub_cause_code_type__struct.h"

/// Struct defined in msg/CauseCode in the package etsi_its_denm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_msgs__msg__CauseCode
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// CauseCode ::= SEQUENCE {
  ///     causeCode CauseCodeType,
  ///     subCauseCode SubCauseCodeType,
  ///         ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_msgs__msg__CauseCodeType cause_code;
  etsi_its_denm_msgs__msg__SubCauseCodeType sub_cause_code;
} etsi_its_denm_msgs__msg__CauseCode;

// Struct for a sequence of etsi_its_denm_msgs__msg__CauseCode.
typedef struct etsi_its_denm_msgs__msg__CauseCode__Sequence
{
  etsi_its_denm_msgs__msg__CauseCode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_msgs__msg__CauseCode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__CAUSE_CODE__STRUCT_H_
