// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_msgs:msg/DecentralizedEnvironmentalNotificationMessage.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__DECENTRALIZED_ENVIRONMENTAL_NOTIFICATION_MESSAGE__STRUCT_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__DECENTRALIZED_ENVIRONMENTAL_NOTIFICATION_MESSAGE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'management'
#include "etsi_its_denm_msgs/msg/detail/management_container__struct.hpp"
// Member 'situation'
#include "etsi_its_denm_msgs/msg/detail/situation_container__struct.hpp"
// Member 'location'
#include "etsi_its_denm_msgs/msg/detail/location_container__struct.hpp"
// Member 'alacarte'
#include "etsi_its_denm_msgs/msg/detail/alacarte_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_msgs__msg__DecentralizedEnvironmentalNotificationMessage __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_msgs__msg__DecentralizedEnvironmentalNotificationMessage __declspec(deprecated)
#endif

namespace etsi_its_denm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DecentralizedEnvironmentalNotificationMessage_
{
  using Type = DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator>;

  explicit DecentralizedEnvironmentalNotificationMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : management(_init),
    situation(_init),
    location(_init),
    alacarte(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->situation_is_present = false;
      this->location_is_present = false;
      this->alacarte_is_present = false;
    }
  }

  explicit DecentralizedEnvironmentalNotificationMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : management(_alloc, _init),
    situation(_alloc, _init),
    location(_alloc, _init),
    alacarte(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->situation_is_present = false;
      this->location_is_present = false;
      this->alacarte_is_present = false;
    }
  }

  // field types and members
  using _management_type =
    etsi_its_denm_msgs::msg::ManagementContainer_<ContainerAllocator>;
  _management_type management;
  using _situation_type =
    etsi_its_denm_msgs::msg::SituationContainer_<ContainerAllocator>;
  _situation_type situation;
  using _situation_is_present_type =
    bool;
  _situation_is_present_type situation_is_present;
  using _location_type =
    etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator>;
  _location_type location;
  using _location_is_present_type =
    bool;
  _location_is_present_type location_is_present;
  using _alacarte_type =
    etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator>;
  _alacarte_type alacarte;
  using _alacarte_is_present_type =
    bool;
  _alacarte_is_present_type alacarte_is_present;

  // setters for named parameter idiom
  Type & set__management(
    const etsi_its_denm_msgs::msg::ManagementContainer_<ContainerAllocator> & _arg)
  {
    this->management = _arg;
    return *this;
  }
  Type & set__situation(
    const etsi_its_denm_msgs::msg::SituationContainer_<ContainerAllocator> & _arg)
  {
    this->situation = _arg;
    return *this;
  }
  Type & set__situation_is_present(
    const bool & _arg)
  {
    this->situation_is_present = _arg;
    return *this;
  }
  Type & set__location(
    const etsi_its_denm_msgs::msg::LocationContainer_<ContainerAllocator> & _arg)
  {
    this->location = _arg;
    return *this;
  }
  Type & set__location_is_present(
    const bool & _arg)
  {
    this->location_is_present = _arg;
    return *this;
  }
  Type & set__alacarte(
    const etsi_its_denm_msgs::msg::AlacarteContainer_<ContainerAllocator> & _arg)
  {
    this->alacarte = _arg;
    return *this;
  }
  Type & set__alacarte_is_present(
    const bool & _arg)
  {
    this->alacarte_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_msgs__msg__DecentralizedEnvironmentalNotificationMessage
    std::shared_ptr<etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_msgs__msg__DecentralizedEnvironmentalNotificationMessage
    std::shared_ptr<etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DecentralizedEnvironmentalNotificationMessage_ & other) const
  {
    if (this->management != other.management) {
      return false;
    }
    if (this->situation != other.situation) {
      return false;
    }
    if (this->situation_is_present != other.situation_is_present) {
      return false;
    }
    if (this->location != other.location) {
      return false;
    }
    if (this->location_is_present != other.location_is_present) {
      return false;
    }
    if (this->alacarte != other.alacarte) {
      return false;
    }
    if (this->alacarte_is_present != other.alacarte_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const DecentralizedEnvironmentalNotificationMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DecentralizedEnvironmentalNotificationMessage_

// alias to use template instance with default allocator
using DecentralizedEnvironmentalNotificationMessage =
  etsi_its_denm_msgs::msg::DecentralizedEnvironmentalNotificationMessage_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_msgs

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__DECENTRALIZED_ENVIRONMENTAL_NOTIFICATION_MESSAGE__STRUCT_HPP_
